// moeview.cpp : implementation of the CMoeView class
//

#include "stdafx.h"
#include "moe.h"

#include "moedoc.h"
#include "moeview.h"

#include "mouse.hpp"
#include "channel.hpp"
#include "demo.hpp"
#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CMoeView

IMPLEMENT_DYNCREATE(CMoeView, CView)

BEGIN_MESSAGE_MAP(CMoeView, CView)
	//{{AFX_MSG_MAP(CMoeView)
	ON_WM_SIZE()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMoeView construction/destruction

CMoeView::CMoeView()
{
	// TODO: add construction code here
	ch = NULL;
	mouse= NULL;
}

CMoeView::~CMoeView()
{
	delete mouse;
	delete ch;
	cleanup();
}

/////////////////////////////////////////////////////////////////////////////
// CMoeView drawing

void CMoeView::OnDraw(CDC* pDC)
{
	CMoeDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CMoeView printing

BOOL CMoeView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMoeView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CMoeView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CMoeView diagnostics

#ifdef _DEBUG
void CMoeView::AssertValid() const
{
	CView::AssertValid();
}

void CMoeView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMoeDoc* CMoeView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMoeDoc)));
	return (CMoeDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMoeView message handlers

void CMoeView::OnInitialUpdate() 
{
	// TODO: Add your specialized code here and/or call the base class
	V3 pos;

	CView::OnInitialUpdate();

	if (ch == NULL) {	
		ch = new channelClass ((void *)m_hWnd);
		ch->setNearPlane(0.001);
	}
	if (mouse == NULL) {	
		mouse = new mouseClass (m_hWnd);
		mouse->attachChannel(ch);
		
		V3_set(pos, 0.0, 0.0, 10.0);
		ch->setPosition(pos);

		init();
	}
}

BOOL CMoeView::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	cs.style = cs.style | WS_CLIPSIBLINGS | WS_CLIPCHILDREN;

	return CView::PreCreateWindow(cs);
}

void CMoeView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	if (!IsWindowVisible() || ch==NULL) return;
	ch->resetPerspective();
	
}

void CMoeView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	
	CView::OnKeyDown(nChar, nRepCnt, nFlags);

	processChar(nChar);
}
