//**********************************************************************
//  DIVE Laboratories, Inc.
//  Copyright(c) 1995
//  All rights reserved.
//
//  FILE:   KINE.HPP
//
//  DESCRIPTION
//  This header provides the class definition for the 
//  kinematicClass class.
//
//**********************************************************************
#ifndef KINEMATIC
#define KINEMATIC

#include "vrtypes.hpp"

class geometryClass;
//---------------------------------------------------------------------
//  This is the class definition for the kinematicClass.
//
class kinematicClass {

//  Private Data

private:

	double tauFactor;
	int    computeTau;
	geometryClass *geo;

protected:

// Public Data

public:

   V3 position, velocity, acceleration;

// Data control

   void setPos(V3 pos);

   void setVel(V3 vel);

   void setAccel(V3 accel);

// Visible geometry

   void setGeo(geometryClass *g);
   geometryClass *getGeo();

// Kinematics

   void kinematic(void);

// Constructor Functions
 
   kinematicClass(V3 pos, V3 vel, V3 accel);

   kinematicClass (int computeTauValueFromClock = 0,
						 double tau = 0.1);

// Destructor Function

   ~kinematicClass(); 
    
};

#endif



